package anbo.easj.dk.locationmanagerexample;

import android.app.Activity;
import android.location.Location;
import android.location.LocationListener;
import android.location.LocationManager;
import android.os.Bundle;
import android.util.Log;
import android.widget.TextView;

// http://developer.android.com/guide/topics/location/strategies.html
public class MainActivity extends Activity {
    private LocationManager locationManager;
    private LocationListener locationListener;
    private TextView latitudeView, longitudeView, altitudeView;
    private static final int minimumTime = 0;
    private static final int minimumDistance = 0;


    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        latitudeView = (TextView) findViewById(R.id.latitude);
        longitudeView = (TextView) findViewById(R.id.longitude);
        altitudeView = (TextView) findViewById(R.id.altitude);
        locationManager = (LocationManager) this.getSystemService(LOCATION_SERVICE);
        Location lastKnownLocation = locationManager.getLastKnownLocation(LocationManager.NETWORK_PROVIDER);
        // NETWORK_PROVIDER = phone cell towers OR wifi
        showLocation(lastKnownLocation);
        locationListener = new LocationListener() {
            public void onLocationChanged(Location location) {
                // Called when a new location is found by the network location provider.
                showLocation(location);
            }

            public void onStatusChanged(String provider, int status, Bundle extras) {
            }

            public void onProviderEnabled(String provider) {
            }

            public void onProviderDisabled(String provider) {
            }
        };

        locationManager.requestLocationUpdates(LocationManager.NETWORK_PROVIDER, minimumTime, minimumDistance, locationListener);
    }

    private void showLocation(Location location) {
        latitudeView.setText("Latitude: " + location.getLatitude());
        longitudeView.setText("Longitude: " + location.getLongitude());
        altitudeView.setText("Altitude: " + location.getAltitude());
        final String message = String.format("Lat %s Lon %s Alt %s", location.getLatitude(), location.getLongitude(), location.getAltitude());
        Log.d("MINE", message);
    }

    @Override
    protected void onPause() {
        super.onPause();
        locationManager.removeUpdates(locationListener);
    }

    //http://stackoverflow.com/questions/10459109/requestlocationupdates-recalls-onpause-and-onresume-infinitely
    @Override
    protected void onResume() {
        super.onResume();
        locationManager.requestLocationUpdates(LocationManager.NETWORK_PROVIDER, minimumTime, minimumDistance, locationListener);
    }
}
